-module(n4u_error).

-export([error_page/3]).

% Plain text error page render
%
% ERROR:  error:badarith
%
% STACK:  index:body/0 : line 18
%         index:main/0 : line 8
%         n4u_document:run/1 : line 15

error_page(Class, Error, Stacktrace) ->
  io_lib:format("ERROR:  ~p:~p~n~n", [Class, Error]) ++
    "STACK: " ++
    [ nitro:render([io_lib:format("\t~p:~p/~p : line ~p",
        [Module, Function, Arity, proplists:get_value(line, Location) ]), "\n"])
    ||  {Module, Function, Arity, Location} <- Stacktrace ].

