-module(n4u_syn).

-export([send/2, reg/1, reg/2, unreg/1]).


send(Pool, Message) -> syn:publish(erlang:term_to_binary(Pool), Message).


reg(Pool) -> reg(Pool, undefined).

reg(Pool, _Value) ->
  case erlang:get({pool, Pool}) of
    undefined ->
      syn:join(erlang:term_to_binary(Pool), erlang:self()),
      erlang:put({pool, Pool}, Pool);
    _Defined -> skip
  end.


unreg(Pool) ->
  case erlang:get({pool, Pool}) of
    undefined -> skip;
    _Defined ->
      syn:leave(erlang:term_to_binary(Pool), erlang:self()), 
      erlang:erase({pool, Pool})
  end.

